  dim IP$(9)
  dim IPSTATUS$(9)
  dim TSTATIP$(9)
  dim HSCHEDULE0$(7)
  dim HSCHEDULE1$(7)
  dim HSCHEDULE2$(7)
  dim HSCHEDULE3$(7)
  dim HSCHEDULE4$(7)
  dim HSCHEDULE5$(7)
  dim HSCHEDULE6$(7)
  dim CSCHEDULE0$(7)
  dim CSCHEDULE1$(7)
  dim CSCHEDULE2$(7)
  dim CSCHEDULE3$(7)
  dim CSCHEDULE4$(7)
  dim CSCHEDULE5$(7)
  dim CSCHEDULE6$(7)
  dim SCHEDULE$(2,7)
  dim TSTAT$(18,2)
  dim SYS$(6,2)
  dim SYSNAMES$(2,2)
  dim SYSHANDLERS$(13,3)
  dim SYSNETWORK$(12,2)
  dim CLOUD$(5,2)
  dim DAY$(7)

  for x=0 to 9
     IP$(x)=""
     TSTATIP$(x)=""
  next x

  for x=0 to 6
    HSCHEDULE0$(x)=""
    HSCHEDULE1$(x)=""
    HSCHEDULE2$(x)=""
    HSCHEDULE3$(x)=""
    HSCHEDULE4$(x)=""
    HSCHEDULE5$(x)=""
    HSCHEDULE6$(x)=""
    CSCHEDULE0$(x)=""
    CSCHEDULE1$(x)=""
    CSCHEDULE2$(x)=""
    CSCHEDULE3$(x)=""
    CSCHEDULE4$(x)=""
    CSCHEDULE5$(x)=""
    CSCHEDULE6$(x)=""
  next x

  IPIndex=99
  TSTATIndex=99

  TSTAT$(0,0)="temp" 
  TSTAT$(1,0)="tmode"
  TSTAT$(2,0)="fmode"
  TSTAT$(3,0)="override"
  TSTAT$(4,0)="hold"
  TSTAT$(5,0)="t_heat"
  TSTAT$(6,0)="t_cool"
  TSTAT$(7,0)="a_heat"
  TSTAT$(8,0)="a_cool"
  TSTAT$(9,0)="a_mode"
  TSTAT$(10,0)="t_type_post"
  TSTAT$(11,0)="tstate" 
  TSTAT$(12,0)="fstate"
  TSTAT$(13,0)="time"
  TSTAT$(14,0)="model"
  TSTAT$(15,0)="led"
  TSTAT$(16,0)="uma"
  TSTAT$(17,0)="pma"

  SYS$(0,0)="uuid"
  SYS$(1,0)="api_version"
  SYS$(2,0)="fw_version"
  SYS$(3,0)="wlan_fw_version"
  SYS$(4,0)="service_names"
  SYS$(5,0)="httpd_handlers"

  SYSNAMES$(0,0)="com.rtcoa.tstat"
  SYSNAMES$(1,0)="devices.controller.tstat"

  SYSHANDLERS$(0,0)="/tstat"
  SYSHANDLERS$(1,0)="/cloud"
  SYSHANDLERS$(2,0)="/sys/network"
  SYSHANDLERS$(3,0)="/sys/updater"
  SYSHANDLERS$(4,0)="/sys/filesystem"
  SYSHANDLERS$(5,0)="/sys/firmware"
  SYSHANDLERS$(6,0)="/sys/fs-image"
  SYSHANDLERS$(7,0)="/sys/fw-image"
  SYSHANDLERS$(8,0)="/sys/command"
  SYSHANDLERS$(9,0)="/sys/services"
  SYSHANDLERS$(10,0)="/sys/mode"
  SYSHANDLERS$(11,0)="/sys/name"
  SYSHANDLERS$(12,0)="/sys/reboot"

  SYSNETWORK$(0,0)="ssid"
  SYSNETWORK$(1,0)="bssid"
  SYSNETWORK$(2,0)="channel"
  SYSNETWORK$(3,0)="security"
  SYSNETWORK$(4,0)="ip"
  SYSNETWORK$(5,0)="dhcp"
  SYSNETWORK$(6,0)="ipaddr"
  SYSNETWORK$(7,0)="ipmask"
  SYSNETWORK$(8,0)="ipgw"
  SYSNETWORK$(9,0)="ipdsn1"
  SYSNETWORK$(10,0)="ipdsn2"
  SYSNETWORK$(11,0)="rssi"

  CLOUD$(0,0)="interval"
  CLOUD$(1,0)="url"
  CLOUD$(2,0)="status"
  CLOUD$(3,0)="enabled"
  CLOUD$(4,0)="authkey"

  DAY$(0)="Monday"
  DAY$(1)="Tuesday"
  DAY$(2)="Wednesday"
  DAY$(3)="Thursday"
  DAY$(4)="Friday"
  DAY$(5)="Saturday"
  DAY$(6)="Sunday"

  ACTION$="Main Menu"

[Main]
  on error goto [MainErrorHandler] 
  cls 
  button #GetIPList, "Get IP List", [GetIPListClicked]
  if IPIndex<>99 then button #PutIPList, "Save IP List", [SaveIPListClicked]
  button #AddIP, "Add an IP", [AddIPClicked]
  if IPIndex<>99 then button #deleteIP, "Delete an IP", [DeleteIPClicked]
  print : print "IP List:";: listbox #IPs, IP$(), 1
  if IP$(IPINDEX)<>"" then
    button #ACCEPTIP, "Select IP", [SelectIP]
    print "Selected IP : ";IP$(IPIndex)
  end if
  if IPIndex<>99 then
  #IPs SELECT(IP$(IPIndex))
    if #IPs SELECTION$()<>"" then
      if IPSTATUS$(IPIndex)="Unknown" or IPSTATUS$(IPIndex)="No Response" then
        button #TestIP, "Test IP", [TestIPClicked]
        STATUS$="Test this IP"
      end if
      if IPSTATUS$(IPIndex)="Responded" then
        button #TestForThermostat, "Test For Thermostat", [TestForThermostatClicked] 
        STATUS$="Test This IP For a Thermostat"
      end if
      print "IP Status:";IPSTATUS$(IPIndex)
    end if
  else
    print
    STATUS$="Add or Get IPs"
  end if
  if TSTATIndex<>99 then
    print "Thermostat List:"; : listbox #TSTATIPs, TSTATIP$(), 1 
    if IP$(IPINDEX)<>"" then
      button #ACCEPTISTAT, "Select IP", [SelectThermostat]
      print "Selected Thermostat : ";TSTATIP$(TSTATIndex)
    end if
    #TSTATIPs SELECT(TSTATIP$(TSTATIndex))
    button #SelectTSTATIP, "Display Selected Thermostat", [TSTATClicked] : print
    STATUS$="You Can View This Thermostat"
   else
    print
  end if
  print "Command Status:"; : textbox #STATUS, STATUS$, 40 : print
  print "Error Status:"; : textbox #ESTATUS, ESTATUS$, 50 : print
  wait

[SelectIP]
  ESTATUS$="no error"
  gosub [IPsListboxIndex]
  #IPs SELECT(IPIndex)
  goto [Main]

[SelectThermostat]
  ESTATUS$="no error"
  gosub [TSTATIPsListboxIndex]
  #TSTATIPs SELECT(TSTATIP$(TSTATIndex))
  searchTSTATIP$=TSTATIP$(TSTATIPIndex)   
  goto [Main]

[GetIPListClicked]
  ESTATUS$="no error"
  open "projects\IPList_project\IPList.txt" for input as #IPList
  x=0

[GetIPListLoop]
  if eof(#IPList)=0 then
    line input #IPList, IP$(x)
    IPSTATUS$(x)="Unknown"
    x=x+1
    goto [GetIPListLoop]
  end if
  close #IPList
  IPIndex=0
  goto [Main]

[SaveIPListClicked]
  ESTATUS$="no error"
  open "projects\IPList_project\IPList.txt" for output as #IPList
  x=0

[SaveIPListLoop]
  if IP$(x)<>"" then
     print #IPList, IP$(x)
    x=x+1
    goto [SaveIPListLoop]
  end if
  close #IPList
  goto [Main]

[AddIPClicked]
  ESTATUS$="no error"
  for x=0 to 9
     if IP$(x)="" then
       input " Input an IP"; IP$(x)
       IPSTATUS$(x)="Unknown"
       exit for
     end if
  next x
  goto [Main]

[DeleteIPClicked]
  ESTATUS$="no error"
  input "Delete ";#IPs SELECTION$();" (y/n)"; temp$
  if temp$="Y" or temp$="y" then
     gosub [IPsListboxIndex]
     IP$(IPIndex)=""
     for x=IPIndex to (9-1)
       IP$(x)=IP$(x+1)
       IPSTATUS$(x)=IPSTATUS$(x+1)
     next x
     IP$(9)="" : IPSTATUS$(9)=""
  end if
  #IPs SELECT(IP$(0))
  gosub [IPsListboxIndex]
  goto [Main]

[IPsListboxIndex]
  ESTATUS$="no error"
  IPIndex=99
  if #IPs SELECTION$()<>"" then
     for x=0 to 9
       if IP$(x)=#IPs SELECTION$() then
          IPIndex=x
          exit for
       end if
     next x
  end if
  return

[TSTATIPsListboxIndex]
  ESTATUS$="no error"
  TSTATIndex=99
  if #TSTATIPs SELECTION$()<>"" then
     for x=0 to 9
       if TSTATIP$(y)=#TSTATIPs SELECTION$() then
          TSTATIndex=x
          exit for
       end if
     next x
  end if
  return

[TestIPClicked]
  ESTATUS$="no error"
  gosub [IPsListboxIndex]
  #IPs SELECT(IPIndex)
  if IP$(IPIndex)="" then
     STATUS$="Choose an IP"
  else
'    if IPSTATUS$(IPIndex)="Unknown" then
      searchIP$=IP$(IPIndex)
      response$=shell$("ping -n 1 ";searchIP$)
      goodresponse$="Reply from ";searchIP$
      if instr(response$,goodresponse$) then
        IPSTATUS$(IPIndex)="Responded"
      else
        IPSTATUS$(IPIndex)="No Response"
      end if
      STATUS$="Finished Searching"
'    else
'      STATUS$="Already Responds"
'    end if
  end if
  goto [Main]

[TestForThermostatClicked]
  ESTATUS$="no error"
  STATUS$="Thermostat Not Found"
  url$="http://";searchIP$;"/sys"
  r$=httpget$(url$)
  for x=0 to 9
     if TSTATIP$(x)="" then
        TSTATIP$(x)=IP$(IPIndex)
        TSTATIndex=x
        STATUS$="Thermostat Found"
        IPSTATUS$(IPIndex)="Thermostat"
        exit for
     end if
  next x
  goto [Main]

[TSTATClicked]
  ESTATUS$="no error"
  searchTSTATIP$=TSTATIP$(TSTATIPIndex)
  url$="http://";searchTSTATIP$;"/tstat"
  r$=httpget$(url$)
  for x=0 to 13
    temp$=TSTAT$(x,0)
    gosub [LookThroughResponse]
    TSTAT$(x,1)=temp$
  next x
  mode$="TSTAT"
  ACTION$="Thermostat at IP ";searchIP$
  goto [Thermostat]

[SYSClicked]
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/sys"
  r$=httpget$(url$)
  position=instr(r$,SYS$(0,0))
  if position<>0 then
     startposition=instr(r$,":",position)+2
     endposition=instr(r$,chr$(34),startposition)   
     SYS$(0,1)=mid$(r$,startposition,endposition-startposition)
  else
     SYS$(0,1)=""
  end if
  position=instr(r$,SYS$(1,0))
  if position<>0 then
     startposition=instr(r$,":",position)+1
     endposition=instr(r$,",",startposition)   
     SYS$(1,1)=mid$(r$,startposition,endposition-startposition)
  else
     SYS$(1,1)=""
  end if
  position=instr(r$,SYS$(2,0))
  if position<>0 then
     startposition=instr(r$,":",position)+2
     endposition=instr(r$,chr$(34),startposition)   
     SYS$(2,1)=mid$(r$,startposition,endposition-startposition)
  else
     SYS$(2,1)=""
  end if
  position=instr(r$,SYS$(3,0))
  if position<>0 then
     startposition=instr(r$,":",position)+2
     endposition=instr(r$,chr$(34),startposition)   
     SYS$(3,1)=mid$(r$,startposition,endposition-startposition)
  else
     SYS$(3,1)=""
  end if
  ACTION$="Thermostat at ";IP$(IPIndex)
  mode$="SYS"
  goto [Thermostat]

[CLOUDClicked]
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/cloud"
  r$=httpget$(url$)
  for x=0 to 4
    gosub [CLOUDATTRIBUTE]
  next x
  mode$="CLOUD"
  goto [Thermostat]

[MainErrorHandler]
  ESTATUS$=Err$;" from ";searchIP$
  goto [Main]

[ThermostatErrorHandler]
  ESTATUS$=Err$;" from ";searchIP$
  goto [Thermostat]

[Thermostat]
  on error goto [ThermostatErrorHandler]
  cls
  textbox #ACTION, ACTION$, 40 : print
  button #BackToMain, "Main", [BackToMainClicked]
  if mode$="TSTAT" then 
    TSTAT$="Dynamic State (refresh)" 
  else
    TSTAT$="Dynamic State" 
  end if 
  button #TSTAT, TSTAT$, [TSTATClicked]

  if mode$="SYS" then 
    SYS$="System Info (refresh)"
  else
    SYS$="System Info"
  end if
  button #TSYS, SYS$, [SYSClicked]

  if mode$="SYSSERVICES" then 
    SYSSERVICES$="System Services (refresh)"
  else  
    SYSSERVICES$="System Services"
  end if
  button #SYSSERVICES, SYSSERVICES$, [SYSSERVICESClicked]

  if mode$="CLOUD" then
    CLOUD$="Cloud Info(refresh)"
  else
    CLOUD$="Cloud Info"
  end if
  button #CLOUD, CLOUD$, [CLOUDClicked] 

  if mode$="SCHEDULE" then
    SCHEDULE$="Daily Schedule (refresh)"
  else
    SCHEDULE$="Daily Schedule"
  end if
  button #SCHEDULE, SCHEDULE$, [SCHEDULEClicked] : print
 
  print

  select case mode$
    case "SYS"
      print "UUID="; : textbox #uuid, SYS$(0,1), 12 : print
      print "API Version="; : textbox #APIVERSION, SYS$(1,1), 5 : print
      print "Firmware Version="; : textbox #FWVERSION, SYS$(2,1), 12 : print
      print "Wireless LAN Version="; : textbox #WLANFWVERSION, SYS$(3,1), 12 : print
      print "Error Status:"; : textbox #ESTATUS, ESTATUS$, 50 : print
      wait

    case "TSTAT"
      print "Temp="; : textbox #TEMP, TSTAT$(0,1), 5     
      button #TEMPGET, "GET", [TEMPGETClicked] : print

      print "TMode="; : textbox #TMODE, TSTAT$(1,1), 5 
      button #TMODEGET, "GET", [TMODEGETClicked]
      button #TMODEPOST, "POST", [TMODEPOSTClicked] : print 

      print "FMode="; : textbox #FMODE, TSTAT$(2,1), 5 
      button #FMODEGET, "GET", [FMODEGETClicked]
      button #FMODEPOST, "POST", [FMODEPOSTClicked] : print 

      print "Override="; : textbox #OVERRIDE, TSTAT$(3,1), 5 
      button #OVERRIDEGET, "GET", [OVERRIDEGETClicked] : print 

      print "Hold="; : textbox #HOLD, TSTAT$(4,1), 5 
      button #HOLDGET, "GET", [HOLDGETClicked]
      button #HOLDPOST, "POST", [HOLDPOSTClicked] : print

      print "T_Heat="; : textbox #THEAT, TSTAT$(5,1), 5 
      button #THEATGET, "GET", [THEATGETClicked]
      button #THEATPOST, "POST", [THEATPOSTClicked] : print

      print "T_Cool="; : textbox #TCOOL, TSTAT$(6,1), 5 
      button #TCOOLGET, "GET", [TCOOLGETClicked]
      button #TCOOLPOST, "POST", [TCOOLPOSTClicked] : print

      print "A_Heat="; : textbox #AHEAT, TSTAT$(7,1), 5
      button #AHEATGET, "GET", [AHEATGETClicked]
      button #AHEATPOST, "POST", [AHEATPOSTClicked] : print  

      print "A_Cool="; : textbox #ACOOL, TSTAT$(8,1), 5    
      button #ACOOLGET, "GET", [ACOOLGETClicked]
      button #ACOOLPOST, "POST", [ACOOLPOSTClicked] : print

      print "A_Mode="; : textbox #AMODE, TSTAT$(9,1), 5  
      button #AMODEPOST, "POST", [AMODEPOSTClicked] : print

      print "T_Type_Post="; : textbox #TTYPEPOST, TSTAT$(10,1), 5 
      button #TTYPEPOSTGET, "GET", [TTYPEPOSTGETClicked] : print

      print "TState="; : textbox #TSTATE, TSTAT$(11,1), 5 
      button #TSTATEGET, "GET", [TSTATEGETClicked] : print

      print "FState="; : textbox #FSTATE, TSTAT$(12,1), 5  
      button #FSTATEGET, "GET", [FSTATEGETClicked] : print

      gosub [TIMEATTRIBUTE]
      print "Time="; : textbox #TIME, DAY$(day);", ";hour;":";minute, 15

      button #TIMEGET, "GET", [TIMEGETClicked]
      button #TIMEPOST, "POST", [TIMEPOSTClicked] : print

      print "Model="; : textbox #MODEL, TSTAT$(14,1), 15 
      button #MODELGET, "GET", [MODELGETClicked] : print 

      print "LED Status="; : textbox #LED, TSTAT$(15,1), 5
      button #LEDPOST, "POST", [LEDPOSTClicked] : print  

      print "UMA Line="; : textbox #UMALINE, str$(umaline), 1 
      print "UMA Message="; : textbox #UMALMESSAGE, umamessage$, 1  
      button #UMAOST, "POST", [UMAPOSTClicked] : print

      print "PMA Line="; : textbox #PMALINE, str$(pmaline), 1 
      print "PMA Message="; : textbox #PMALMESSAGE, pmamessage$, 1
      button #PMAPOST, "POST", [PMAPOSTClicked] : print

      print "Error Status:"; : textbox #ESTATUS, ESTATUS$, 50 : print
      wait

    case "CLOUD"
      print "  Interval="; : textbox #INTERVAL, CLOUD$(0,1), 12 : print
      print "  URL="; : textbox #URL, CLOUD$(1,1), 50 : print
      print "  Status="; : textbox #STATUS, CLOUD$(2,1), 12 : print
      print "  Enabled="; : textbox #ENABLED, CLOUD$(3,1), 12 : print
      print "  Authorization Key="; : textbox #AUTHKEY, CLOUD$(4,1), 12 : print

      print "Error Status:"; : textbox #ESTATUS, ESTATUS$, 50 : print
      wait

   case "SYSSERVICES"
      gosub [SERVICESATTRIBUTE]
      print "Service Names:"
      print "  RTCOA Thermostat="; : textbox #COMRTCOATSTAT, SYSNAMES$(0,1), 12 : print
      print "  Thermostat Controller="; : textbox #DEVICESCONTROLLERTSTAT, SYSNAMES$(1,1), 12 : print
      gosub [HANDLERSATTRIBUTE]
      print "HTTP Device Handlers:"
      gosub [NETWORKATTRIBUTE]
      print "  Network:";
      if instr(SYSHANDLERS$(2,1),"GET") then button #SYSNETWORKGET, "GET", [SYSNETWORKGETClicked]
      if instr(SYSHANDLERS$(2,1),"POST") then button #SYSNETWORKPOST, "POST", [SYSNETWORKPOSTClicked] 
      print
      print "    SSID="; : textbox #SSID, SYSNETWORK$(0,1), 12 : print
      print "    BSSID="; : textbox #BSSID, SYSNETWORK$(1,1), 20 : print
      print "    Channel="; : textbox #CHANNEL, SYSNETWORK$(2,1), 12 : print
      print "    Security="; : textbox #SECURITY, SYSNETWORK$(3,1), 12 : print
      print "    IP="; : textbox #IP, SYSNETWORK$(4,1), 12 : print
      print "    DHCP="; : textbox #DHCP, SYSNETWORK$(5,1), 12 : print
      print "    IP Address="; : textbox #IPADDR, SYSNETWORK$(6,1), 12 : print
      print "    IP Mask="; : textbox #IPMASK, SYSNETWORK$(7,1), 12 : print
      print "    IP Gateway="; : textbox #IPGW, SYSNETWORK$(8,1), 12 : print
      print "    IP DSN1="; : textbox #IPDSN1, SYSNETWORK$(9,1), 12 : print
      print "    IP DSN2="; : textbox #IPDSN2, SYSNETWORK$(10,1), 12 : print
      print "    RSSI="; : textbox #RSSI, SYSNETWORK$(11,1), 12 : print

      print "  Updater="; : textbox #SYSUPDATER, SYSHANDLERS$(3,2),  8 
      if instr(SYSHANDLERS$(3,1),"GET") then button #SYSUPDATERGET, "GET", [SYSUPDATERGETClicked]
      if instr(SYSHANDLERS$(3,1),"POST") then button #SYSUPDATERPOST, "POST", [SYSUPDATERPOSTClicked] 
      print

      print "  File System="; : textbox #SYSFILESYSTEM, SYSHANDLERS$(4,2),  8 
      if instr(SYSHANDLERS$(4,1),"GET") then button #SYSFILESYSTEMGET, "GET", [SYSFILESYSTEMGETClicked]
      if instr(SYSHANDLERS$(4,1),"POST") then button #SYSFILESYSTEMPOST, "POST", [SYSFILESYSTEMPOSTClicked] 
      print

      print "  File System Image="; : textbox #SYSFSIMAGE, SYSHANDLERS$(6,2),  8 
      if instr(SYSHANDLERS$(6,1),"GET") then button #SYSFSIMAGEGET, "GET", [SYSFSIMAGEGETClicked]
      if instr(SYSHANDLERS$(6,1),"POST") then button #SYSFSIMAGEPOST, "POST", [SYSFSIMAGEPOSTClicked] 
      print

      print "  Firmware Image="; : textbox #SYSFWIMAGE, SYSHANDLERS$(7,2),  8 
      if instr(SYSHANDLERS$(7,1),"GET") then button #SYSFWIMAGEGET, "GET", [SYSFWIMAGEGETClicked]
      if instr(SYSHANDLERS$(7,1),"POST") then button #SYSFWIMAGEPOST, "POST", [SYSFWIMAGEPOSTClicked] 
      print

      print "  Command="; : textbox #SYSCOMMAND, SYSHANDLERS$(8,2),  8
      if instr(SYSHANDLERS$(8,1),"GET") then button #SYSCOMMANDGET, "GET", [SYSCOMMANDGETClicked]
      if instr(SYSHANDLERS$(8,1),"POST") then button #SYSCOMMANDPOST, "POST", [SYSCOMMANDPOSTClicked] 
      print

      print "  Mode="; : textbox #SYSMODE, SYSHANDLERS$(10,2),  8
      if instr(SYSHANDLERS$(10,1),"GET") then button #SYSMODEGET, "GET", [SYSMODEGETClicked]
      if instr(SYSHANDLERS$(10,1),"POST") then button #SYSMODEPOST, "POST", [SYSMODEPOSTClicked] 
      print

      print "  Name="; : textbox #SYSNAME, SYSHANDLERS$(11,2),  25
      if instr(SYSHANDLERS$(11,1),"GET") then button #SYSNAMEGET, "GET", [SYSNAMEGETClicked]
      if instr(SYSHANDLERS$(11,1),"POST") then button #SYSNAMEPOST, "POST", [SYSNAMEPOSTClicked]
      print

      print "  Reboot="; : textbox #SYSREBOOT, SYSHANDLERS$(12,2),  8
      if instr(SYSHANDLERS$(12,1),"GET") then button #SYSREBOOTGET, "GET", [SYSREBOOTGETClicked]
      if instr(SYSHANDLERS$(12,1),"POST") then button #SYSREBOOTPOST, "POST", [SYSREBOOTPOSTClicked] 
      print

      print "Error Status:"; : textbox #ESTATUS, ESTATUS$, 50 : print
      wait

   case "SCHEDULE"
     gosub [HEATATTRIBUTES]
     print "Heating Schedule (Military Time @ Temperature)" : print
     print "  Monday   "; : listbox #MONDAYHSCHEDULE, HSCHEDULE0$(), 1 : print
     print "  Tuesday  "; : listbox #TUESDAYHSCHEDULE, HSCHEDULE1$(), 1 : print
     print "  Wednesday"; : listbox #WEDNESDAYHSCHEDULE, HSCHEDULE2$(), 1 : print
     print "  Thursday "; : listbox #THURSDAYHSCHEDULE, HSCHEDULE3$(), 1 : print
     print "  Friday   "; : listbox #FRIDAYHSCHEDULE, HSCHEDULE4$(), 1 : print
     print "  Saturday "; : listbox #SATURDAYHSCHEDULE, HSCHEDULE5$(), 1 : print
     print "  Sunday   "; : listbox #SUNDAYHSCHEDULE, HSCHEDULE6$(), 1 : print
     #MONDAYHSCHEDULE SELECT(0)
     #TUESDAYHSCHEDULE SELECT(0)
     #WEDNESDAYHSCHEDULE SELECT(0)
     #THURSDAYHSCHEDULE SELECT(0)
     #FRIDAYHSCHEDULE SELECT(0)
     #SATURDAYHSCHEDULE SELECT(0)
     #SUNDAYHSCHEDULE SELECT(0)
     print
     gosub [COOLATTRIBUTES]
     print "Cooling Schedule (Military Time @ Temperature)" : print
     print "  Monday   "; : listbox #MONDAYCSCHEDULE, CSCHEDULE0$(), 1 : print
     print "  Tuesday  "; : listbox #TUESDAYCSCHEDULE, CSCHEDULE1$(), 1 : print
     print "  Wednesday"; : listbox #WEDNESDAYCSCHEDULE, CSCHEDULE2$(), 1 : print
     print "  Thursday "; : listbox #THURSDAYCSCHEDULE, CSCHEDULE3$(), 1 : print
     print "  Friday   "; : listbox #FRIDAYCSCHEDULE, CSCHEDULE4$(), 1 : print
     print "  Saturday "; : listbox #SATURDAYCSCHEDULE, CSCHEDULE5$(), 1 : print
     print "  Sunday   "; : listbox #SUNDAYCSCHEDULE, CSCHEDULE6$(), 1 : print
     #MONDAYCSCHEDULE SELECT(0)
     #TUESDAYCSCHEDULE SELECT(0)
     #WEDNESDAYCSCHEDULE SELECT(0)
     #THURSDAYCSCHEDULE SELECT(0)
     #FRIDAYCSCHEDULE SELECT(0)
     #SATURDAYCSCHEDULE SELECT(0)
     #SUNDAYCSCHEDULE SELECT(0)
     print

     print "Error Status:"; : textbox #ESTATUS, ESTATUS$, 50 : print

     wait
   end select

[BackToMainClicked]
  ACTION$="Main menu"
  goto [Main]

[SYSSERVICESClicked]
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/sys/services"
  r$=httpget$(url$)
  position=instr(r$,SYS$(4,0))
  if position<>0 then
    startposition=instr(r$,"[",position)+1
    endposition=instr(r$,"]",startposition)    
    SYS$(4,1)=mid$(r$,startposition,endposition-startposition)
  else
    SYS$(4,1)=""
  end if
  position=instr(r$,SYS$(5,0))
  if position<>0 then
    startposition=instr(r$,"{",position)+1
    endposition=instr(r$,"}",startposition)    
    SYS$(5,1)=mid$(r$,startposition,endposition-startposition)
  else
    SYS$(5,1)=""
  end if
  ACTION$="Thermostat at ";IP$(IPIndex)
  mode$="SYSSERVICES"
  goto [Thermostat]

[SCHEDULEClicked]
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/tstat/program/heat"
  r$=httpget$(url$)
  for x=0 to 6
    temp$=str$(x)
    gosub [LookThroughResponse]
    SCHEDULE$(0,x)=temp$
  next x

  url$="http://";searchTSTATIP$;"/tstat/program/cool"
  r$=httpget$(url$)
  for x=0 to 6
    temp$=str$(x)
    gosub [LookThroughResponse]
    SCHEDULE$(1,x)=temp$
  next x

  mode$="SCHEDULE"
  goto [Thermostat]

[TIMEATTRIBUTE]
  r$=TSTAT$(13,1)
  temp$="day"
  gosub [LookThroughResponse]
  day=val(temp$)

  temp$="hour"
  gosub [LookThroughResponse]
  hour=val(temp$)

  temp$="minute"
  gosub [LookThroughResponse]
  minute=val(temp$)

  return

[SERVICESATTRIBUTE]
  r$=SYS$(4,1)
  for x=0 to 1
    temp$=SYSNAMES$(x,0)
    gosub [LookThroughResponse]
    SYSNAMES$(x,1)=temp$
  next x
  return

[HANDLERSATTRIBUTE]
  for x=0 to 12
    position=instr(SYS$(5,1),SYSHANDLERS$(x,0))
    if position<>0 then
      position=instr(SYS$(5,1),"[",position)
      endingposition=instr(SYS$(5,1),"]",position)   
      temp$=mid$(SYS$(5,1),position,endingposition-position+1) 
      if temp$="[0,0]" then SYSHANDLERS$(x,1)="N/A"
      if temp$="[1,0]" then SYSHANDLERS$(x,1)="SET"
      if temp$="[0,1]" then SYSHANDLERS$(x,1)="POST"
      if temp$="[1,1]" then SYSHANDLERS$(x,1)="GET/POST"
    else
      SYSHANDLERS$(x,1)=""
    end if
  next x
  return

[NETWORKATTRIBUTE]
  r$=SYSHANDLERS$(2,2)
  for x=0 to 11
    temp$=SYSNETWORK$(x,0)
    gosub [LookThroughResponse]
    SYSNETWORK$(x,1)=temp$
  next x
  return

[CLOUDATTRIBUTE]
  for x=0 to 4
    position=instr(r$,CLOUD$(x,0))
    if position<>0 then
      position=instr(r$,":",position)
      if mid$(r$,position+1,1)=chr$(34) then
        'string
        startposition=position+2
        endposition=instr(r$,chr$(34),startposition)
        CLOUD$(x,1)=mid$(r$,startposition,endposition-startposition) 
      else
        'integer
        startposition=position+1
        CLOUD$(x,1)=str$(val(mid$(r$,startposition)))
      end if
    else
      CLOUD$(x,1)=""
    end if
  next x
  return

[HEATATTRIBUTES]
  x=0
  temp$=SCHEDULE$(0,0)
  while temp$<>""
    h=int(val(temp$)/60) : m=int(val(temp$)-(h*60)) : tm=int(m/10) : um=m-(tm*10)
    HSCHEDULE0$(x)=str$(h);":";str$(tm);str$(um)
    position=instr(temp$,",")
    temp$=right$(temp$,len(temp$)-position)
    HSCHEDULE0$(x)=HSCHEDULE0$(x);" @ ";str$(val(temp$))
    position=instr(temp$,",")
    if position<>0 then     
      temp$=right$(temp$,len(temp$)-position)
    else
      temp$=""
    end if
    x=x+1
  wend
  
  x=0
  temp$=SCHEDULE$(0,1)
  while temp$<>""
    h=int(val(temp$)/60) : m=int(val(temp$)-(h*60)) : tm=int(m/10) : um=m-(tm*10)
    HSCHEDULE1$(x)=str$(h);":";str$(tm);str$(um)
    position=instr(temp$,",")
    temp$=right$(temp$,len(temp$)-position)
    HSCHEDULE1$(x)=HSCHEDULE1$(x);" @ ";str$(val(temp$))
    position=instr(temp$,",")
    if position<>0 then     
      temp$=right$(temp$,len(temp$)-position)
    else
      temp$=""
    end if
    x=x+1
  wend

  x=0
  temp$=SCHEDULE$(0,2)
  while temp$<>""
    h=int(val(temp$)/60) : m=int(val(temp$)-(h*60)) : tm=int(m/10) : um=m-(tm*10)
    HSCHEDULE2$(x)=str$(h);":";str$(tm);str$(um)
    position=instr(temp$,",")
    temp$=right$(temp$,len(temp$)-position)
    HSCHEDULE2$(x)=HSCHEDULE2$(x);" @ ";str$(val(temp$))
    position=instr(temp$,",")
    if position<>0 then     
      temp$=right$(temp$,len(temp$)-position)
    else
      temp$=""
    end if
    x=x+1
  wend

  x=0
  temp$=SCHEDULE$(0,3)
  while temp$<>""
    h=int(val(temp$)/60) : m=int(val(temp$)-(h*60)) : tm=int(m/10) : um=m-(tm*10)
    HSCHEDULE3$(x)=str$(h);":";str$(tm);str$(um)
    position=instr(temp$,",")
    temp$=right$(temp$,len(temp$)-position)
    HSCHEDULE3$(x)=HSCHEDULE3$(x);" @ ";str$(val(temp$))
    position=instr(temp$,",")
    if position<>0 then     
      temp$=right$(temp$,len(temp$)-position)
    else
      temp$=""
    end if
    x=x+1
  wend

  x=0
  temp$=SCHEDULE$(0,4)
  while temp$<>""
    h=int(val(temp$)/60) : m=int(val(temp$)-(h*60)) : tm=int(m/10) : um=m-(tm*10)
    HSCHEDULE4$(x)=str$(h);":";str$(tm);str$(um)
    position=instr(temp$,",")
    temp$=right$(temp$,len(temp$)-position)
    HSCHEDULE4$(x)=HSCHEDULE4$(x);" @ ";str$(val(temp$))
    position=instr(temp$,",")
    if position<>0 then     
      temp$=right$(temp$,len(temp$)-position)
    else
      temp$=""
    end if
    x=x+1
  wend

  x=0
  temp$=SCHEDULE$(0,5)
  while temp$<>""
    h=int(val(temp$)/60) : m=int(val(temp$)-(h*60)) : tm=int(m/10) : um=m-(tm*10)
    HSCHEDULE5$(x)=str$(h);":";str$(tm);str$(um)
    position=instr(temp$,",")
    temp$=right$(temp$,len(temp$)-position)
    HSCHEDULE5$(x)=HSCHEDULE5$(x);" @ ";str$(val(temp$))
    position=instr(temp$,",")
    if position<>0 then     
      temp$=right$(temp$,len(temp$)-position)
    else
      temp$=""
    end if
    x=x+1
  wend

  x=0
  temp$=SCHEDULE$(0,6)
  while temp$<>""
    h=int(val(temp$)/60) : m=int(val(temp$)-(h*60)) : tm=int(m/10) : um=m-(tm*10)
    HSCHEDULE6$(x)=str$(h);":";str$(tm);str$(um)
    position=instr(temp$,",")
    temp$=right$(temp$,len(temp$)-position)
    HSCHEDULE6$(x)=HSCHEDULE6$(x);" @ ";str$(val(temp$))
    position=instr(temp$,",")
    if position<>0 then     
      temp$=right$(temp$,len(temp$)-position)
    else
      temp$=""
    end if
    x=x+1
  wend
  return

[COOLATTRIBUTES]
  x=0
  temp$=SCHEDULE$(1,0)
  while temp$<>""
    h=int(val(temp$)/60) : m=int(val(temp$)-(h*60)) : tm=int(m/10) : um=m-(tm*10)
    CSCHEDULE0$(x)=str$(h);":";str$(tm);str$(um)
    position=instr(temp$,",")
    temp$=right$(temp$,len(temp$)-position)
    CSCHEDULE0$(x)=CSCHEDULE0$(x);" @ ";str$(val(temp$))
    position=instr(temp$,",")
    if position<>0 then     
      temp$=right$(temp$,len(temp$)-position)
    else
      temp$=""
    end if
    x=x+1
  wend
  
  x=0
  temp$=SCHEDULE$(1,1)
  while temp$<>""
    h=int(val(temp$)/60) : m=int(val(temp$)-(h*60)) : tm=int(m/10) : um=m-(tm*10)
    CSCHEDULE1$(x)=str$(h);":";str$(tm);str$(um)
    position=instr(temp$,",")
    temp$=right$(temp$,len(temp$)-position)
    CSCHEDULE1$(x)=CSCHEDULE1$(x);" @ ";str$(val(temp$))
    position=instr(temp$,",")
    if position<>0 then     
      temp$=right$(temp$,len(temp$)-position)
    else
      temp$=""
    end if
    x=x+1
  wend

  x=0
  temp$=SCHEDULE$(1,2)
  while temp$<>""
    h=int(val(temp$)/60) : m=int(val(temp$)-(h*60)) : tm=int(m/10) : um=m-(tm*10)
    CSCHEDULE2$(x)=str$(h);":";str$(tm);str$(um)
    position=instr(temp$,",")
    temp$=right$(temp$,len(temp$)-position)
    CSCHEDULE2$(x)=CSCHEDULE2$(x);" @ ";str$(val(temp$))
    position=instr(temp$,",")
    if position<>0 then     
      temp$=right$(temp$,len(temp$)-position)
    else
      temp$=""
    end if
    x=x+1
  wend

  x=0
  temp$=SCHEDULE$(1,3)
  while temp$<>""
    h=int(val(temp$)/60) : m=int(val(temp$)-(h*60)) : tm=int(m/10) : um=m-(tm*10)
    CSCHEDULE3$(x)=str$(h);":";str$(tm);str$(um)
    position=instr(temp$,",")
    temp$=right$(temp$,len(temp$)-position)
    CSCHEDULE3$(x)=CSCHEDULE3$(x);" @ ";str$(val(temp$))
    position=instr(temp$,",")
    if position<>0 then     
      temp$=right$(temp$,len(temp$)-position)
    else
      temp$=""
    end if
    x=x+1
  wend

  x=0
  temp$=SCHEDULE$(1,4)
  while temp$<>""
    h=int(val(temp$)/60) : m=int(val(temp$)-(h*60)) : tm=int(m/10) : um=m-(tm*10)
    CSCHEDULE4$(x)=str$(h);":";str$(tm);str$(um)
    position=instr(temp$,",")
    temp$=right$(temp$,len(temp$)-position)
    CSCHEDULE4$(x)=CSCHEDULE4$(x);" @ ";str$(val(temp$))
    position=instr(temp$,",")
    if position<>0 then     
      temp$=right$(temp$,len(temp$)-position)
    else
      temp$=""
    end if
    x=x+1
  wend

  x=0
  temp$=SCHEDULE$(1,5)
  while temp$<>""
    h=int(val(temp$)/60) : m=int(val(temp$)-(h*60)) : tm=int(m/10) : um=m-(tm*10)
    CSCHEDULE5$(x)=str$(h);":";str$(tm);str$(um)
    position=instr(temp$,",")
    temp$=right$(temp$,len(temp$)-position)
    CSCHEDULE5$(x)=CSCHEDULE5$(x);" @ ";str$(val(temp$))
    position=instr(temp$,",")
    if position<>0 then     
      temp$=right$(temp$,len(temp$)-position)
    else
      temp$=""
    end if
    x=x+1
  wend

  x=0
  temp$=SCHEDULE$(1,6)
  while temp$<>""
    h=int(val(temp$)/60) : m=int(val(temp$)-(h*60)) : tm=int(m/10) : um=m-(tm*10)
    CSCHEDULE6$(x)=str$(h);":";str$(tm);str$(um)
    position=instr(temp$,",")
    temp$=right$(temp$,len(temp$)-position)
    CSCHEDULE6$(x)=CSCHEDULE6$(x);" @ ";str$(val(temp$))
    position=instr(temp$,",")
    if position<>0 then     
      temp$=right$(temp$,len(temp$)-position)
    else
      temp$=""
    end if
    x=x+1
  wend
  return

[TEMPGETClicked]  
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/tstat/temp"
  r$=httpget$(url$)
  temp$="temp"
  gosub [LookThroughResponse]
  if temp$<>"" then
    TSTAT$(0,1)=temp$
  else
    ESTATUS$=r$
  end if   
  goto [Thermostat]

[TMODEGETClicked] 
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/tstat/tmode"
  r$=httpget$(url$)
  temp$="tmode"
  gosub [LookThroughResponse]
  if temp$<>"" then
    TSTAT$(1,1)=temp$
  else
    ESTATUS$=r$
  end if   
  goto [Thermostat]

[TMODEPOSTClicked]  
  ESTATUS$="no error"
  if #TMODE CONTENTS$()<>"" then
  url$="http://";searchTSTATIP$;"/tstat/tmode"
  temp$="{";chr$(34);"tmode";chr$(34);":";val(#TMODE CONTENTS$());"}"
  r$=httppost$(url$,temp$)
    if instr(r$,"success") then
      TSTAT$(1,1)=#TMODE CONTENTS$() 
    else
      ESTATUS$="Command unsuccessful"
    end if
  else
    ESTATUS$="Nothing to POST"
  end if
  goto [Thermostat]

[FMODEGETClicked] 
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/tstat/fmode"
  r$=httpget$(url$)
  temp$="fmode"
  gosub [LookThroughResponse]
  if temp$<>"" then
    TSTAT$(2,1)=temp$
  else
    ESTATUS$=r$
  end if   
  goto [Thermostat]

[FMODEPOSTClicked]  
  ESTATUS$="no error"
  if #FMODE CONTENTS$() <>"" then
    url$="http://";searchTSTATIP$;"/tstat/fmode"
    temp$="{";chr$(34);"fmode";chr$(34);":";val(#FMODE CONTENTS$());"}"
    r$=httppost$(url$,temp$)
    if instr(r$,"success") then
      TSTAT$(2,1)=#FMODE CONTENTS$() 
    else
      ESTATUS$="Command unsuccessful"
    end if
  else
    ESTATUS$="Nothing to POST"
  end if
  goto [Thermostat]

[OVERRIDEGETClicked] 
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/tstat/override"
  r$=httpget$(url$)
  temp$="override"
  gosub [LookThroughResponse]
  if temp$<>"" then
    TSTAT$(3,1)=temp$
  else
    ESTATUS$=r$
  end if   
  goto [Thermostat]

[HOLDGETClicked]  
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/tstat/hold"
  r$=httpget$(url$)
  temp$="hold"
  gosub [LookThroughResponse]
  if temp$<>"" then
    TSTAT$(4,1)=temp$
  else
    ESTATUS$=r$
  end if   
  goto [Thermostat]

[HOLDPOSTClicked] 
  ESTATUS$="no error"
  if #HOLD CONTENTS$()<>"" then
    url$="http://";searchTSTATIP$;"/tstat/hold"
    temp$="{";chr$(34);"hold";chr$(34);":";val(#HOLD CONTENTS$());"}"
    r$=httppost$(url$,temp$)
    if instr(r$,"success") then
      TSTAT$(4,1)=#HOLD CONTENTS$() 
    else
      ESTATUS$="Command unsuccessful"
    end if
  else
    ESTATUS$="Nothing to POST"
  end if
  goto [Thermostat]

[THEATGETClicked] 
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/tstat/t_heat"
  r$=httpget$(url$)
  temp$="t_heat"
  gosub [LookThroughResponse]
  if temp$<>"" then
    TSTAT$(5,1)=temp$
  else
    ESTATUS$=r$
  end if   
  goto [Thermostat]

[THEATPOSTClicked] 
  ESTATUS$="no error"
  if #THEAT CONTENTS$() <>"" then
    url$="http://";searchTSTATIP$;"/tstat/t_heat"
    temp$="{";chr$(34);"t_heat";chr$(34);":";val(#THEAT CONTENTS$());"}"
    r$=httppost$(url$,temp$)
    if instr(r$,"success") then
      TSTAT$(5,1)=#THEAT SELECTED$()    
    else
    ESTATUS$="Command unsuccessful"
    end if
  else
    ESTATUS$="Nothing to POST"
  end if
  goto [Thermostat]

[TCOOLGETClicked] 
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/tstat/t_cool"
  r$=httpget$(url$)
  temp$="t_cool"
  gosub [LookThroughResponse]
  if temp$<>"" then
    TSTAT$(6,1)=temp$
  else
    ESTATUS$=r$
  end if   
  goto [Thermostat]

[TCOOLPOSTClicked] 
  ESTATUS$="no error"
  if #TCOOL CONTENTS$()<>"" then
    url$="http://";searchTSTATIP$;"/tstat/t_cool"
    temp$="{";chr$(34);"t_cool";chr$(34);":";val(#TCOOL CONTENTS$());"}"
    r$=httppost$(url$,temp$)
    if instr(r$,"success") then
      TSTAT$(6,1)=#TCOOL CONTENTS$()     
    else
      ESTATUS$="Command unsuccessful"
    end if
  else
    ESTATUS$="Nothing to POST"
  end if
  goto [Thermostat]

[AHEATGETClicked]
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/tstat/a_heat"
  r$=httpget$(url$)
  temp$="a_heat"
  gosub [LookThroughResponse]
  if temp$<>"" then
    TSTAT$(7,1)=temp$
  else
    ESTATUS$=r$
  end if   
  goto [Thermostat]

[AHEATPOSTClicked] 
  ESTATUS$="no error"
  if #AHEAT CONTENTS$()<>"" then
    url$="http://";searchTSTATIP$;"/tstat/a_heat"
    temp$="{";chr$(34);"a_heat";chr$(34);":";val(CONTENTS$());"}"
    r$=httppost$(url$,temp$)
    if instr(r$,"success") then
      TSTAT$(7,1)=#AHEAT CONTENTS$() 
    else
      ESTATUS$="Command unsuccessful"
    end if
  else
    ESTATUS$="Nothing to POST"
  end if
  goto [Thermostat]

[ACOOLGETClicked] 
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/tstat/a_cool"
  r$=httpget$(url$)
  temp$="a_cool"
  gosub [LookThroughResponse]
  if temp$<>"" then
    TSTAT$(8,1)=temp$
  else
    ESTATUS$=r$
  end if   
  goto [Thermostat]

[ACOOLPOSTClicked]  
  ESTATUS$="no error"
  if #ACOOL CONTENTS$() <>"" then
    url$="http://";searchTSTATIP$;"/tstat/a_cool"
    temp$="{";chr$(34);"a_cool";chr$(34);":";val(#ACOOL CONTENTS$());"}"
    r$=httppost$(url$,temp$)
    if instr(r$,"success") then
      TSTAT$(8,1)=#ACOOL CONTENTS$() 
    else
      ESTATUS$="Command unsuccessful"
    end if
  else
    ESTATUS$="Nothing to POST"
  end if 
  goto [Thermostat]

[AMODEPOSTClicked]
  ESTATUS$="no error"
  if #AMODE CONTENTS$() <>"" then
    url$="http://";searchTSTATIP$;"/tstat/a_mode"
    temp$="{";chr$(34);"a_mode";chr$(34);":";val(#AMODE CONTENTS$());"}"
    r$=httppost$(url$,temp$)
    if instr(r$,"success") then
      TSTAT$(9,1)=#AMODE CONTENTS$()   
    else
      ESTATUS$="Command unsuccessful"
    end if
  else
    ESTATUS$="Nothing to POST"
  end if
  goto [Thermostat]

[TTYPEPOSTGETClicked] 
  ESTATUS$="no error"
  if #TTYPEPOST CONTENTS$() <>"" then
    url$="http://";searchTSTATIP$;"/tstat/t_type_post"
    temp$="{";chr$(34);"t_type_post";chr$(34);":";val(#TTYPEPOST CONTENTS$());"}"
    r$=httppost$(url$,temp$)
    if instr(r$,"success") then
      TSTAT$(10,1)=#TTYPEPOST CONTENTS$() 
    else
      ESTATUS$=r$
    end if
  else
    ESTATUS$="Nothing to POST"
  end if
  goto [Thermostat]

[TSTATEGETClicked] 
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/tstat/tstate"
  r$=httpget$(url$)
  temp$="tstate"
  gosub [LookThroughResponse]
  if temp$<>"" then
    TSTAT$(11,1)=temp$
  else
    ESTATUS$=r$
  end if   
  goto [Thermostat]


[FSTATEGETClicked]  
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/tstat/fstate"
  r$=httpget$(url$)
  temp$="fstate"
  gosub [LookThroughResponse]
  if temp$<>"" then
    TSTAT$(12,1)=temp$
  else
    ESTATUS$=r$
  end if   
  goto [Thermostat]


[TIMEGETClicked]
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/tstat/time"
  r$=httpget$(url$)
  if instr(r$,"time") then
    TSTAT$(13,1)=r$
  else
    ESTATUS$=r$
  end if   
  goto [Thermostat]

[TIMEPOSTClicked]
  ESTATUS$="no error"
  if #TIME CONTENTS$()<>"" then
    url$="http://";searchTSTATIP$;"/tstat"
    if instr(#TIME CONTENTS$(),"Monday") then day=0
    if instr(#TIME CONTENTS$(),"Tuesday") then day=1
    if instr(#TIME CONTENTS$(),"Wednesday") then day=2
    if instr(#TIME CONTENTS$(),"Thursday") then day=3
    if instr(#TIME CONTENTS$(),"Friday") then day=4
    if instr(#TIME CONTENTS$(),"Saturday") then day=5
    if instr(#TIME CONTENTS$(),"Sunday") then day=6
    position=instr(#TIME CONTENTS$(),", ")
    hour=val(mid$(#TIME CONTENTS$(),position+1))
    position=instr(#TIME CONTENTS$(),":")
    minute=val(MID$(#TIME CONTENTS$(),position+1))
    temp$="{";chr$(34);"time";chr$(34);":"
    temp$=temp$;"{";chr$(34);"day";chr$(34);":";day
    temp$=temp$;",";chr$(34);"hour";chr$(34);":";hour
    temp$=temp$;",";chr$(34);"minute";chr$(34);":";minute;"}";"}"
    r$=httppost$(url$,temp$)
    if instr(temp$,"success") then
      TSTAT$(13,1)=#TIME CONTENTS$()
    else
      ESTATUS$="Command unsuccessful"
    end if
  else
    ESTATUS$="Nothing to POST"
  end if
  goto [Thermostat]

[MODELGETClicked]
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/tstat/model"
  r$=httpget$(url$)
  temp$="model"
  gosub [LookThroughResponse]
  if temp$<>"" then
    TSTAT$(14,1)=temp$
  else
    ESTATUS$="Command unsuccessful"
  end if   
  goto [Thermostat]


[LEDPOSTClicked]
 ESTATUS$="no error"
  if #LED CONTENTS$() <>"" then
    url$="http://";searchTSTATIP$;"/tstat/led"
    temp$="{";chr$(34);"energy_led";chr$(34);":";val(#LED CONTENTS$());"}"
    r$=httppost$(url$,temp$)
    if instr(r$,"success") then
      TSTAT$(15,1)=#LED CONTENTS$() 
    else
      ESTATUS$="Command unsuccessful"
    end if
  else
    ESTATUS$="Nothing to POST"
  end if
  goto [Thermostat]


[UMAPOSTClicked]
 ESTATUS$="no error"
  if #UMALINE CONTENTS$()<>"" and #UMAMESSAGE CONTENTS$()<>"" then
    url$="http://";searchTSTATIP$;"/tstat/uma"
    temp$="{";chr$(34);"line";chr$(34);":";umaline
    temp$=temp$;",";chr$(34);"message";chr$(34);":";chr$(34);umamessage$;chr$(34);"}"
    r$=httppost$(url$,temp$)
    if instr(r$,"success") then
      umaline=val(#UMALINE CONTENTS$())
      umamessage$=#UMAmessage CONTENTS$()
    else
      ESTATUS$="Command unsuccessful"
    end if
  else
    ESTATUS$="Nothing to POST"
  end if
  goto [Thermostat]

[PMAPOSTClicked]
 ESTATUS$="no error"
  if #PMALINE CONTENTS$()<>"" and #PMAMESSAGE CONTENTS$()<>"" then
    url$="http://";searchTSTATIP$;"/tstat/pma"
    temp$="{";chr$(34);"line";chr$(34);":";pmaline
    temp$=temp$;",";chr$(34);"message";chr$(34);":";chr$(34);pmamessage$;chr$(34);"}"
    r$=httppost$(url$,temp$)
    if instr(r$,"success") then
      pmaline=val(#PMALINE CONTENTS$())
      pmamessage$=#PMAmessage CONTENTS$()
    else
      ESTATUS$="Command unsuccessful"
    end if
  else
    ESTATUS$="Nothing to POST"
  end if
  goto [Thermostat]

[LookThroughResponse]
' search string in temp$, result in temp$
  position=instr(r$,temp$)
  if position<>0 then
    position=instr(r$,":",position)
    startposition=position+1
    if mid$(r$,startposition,1)="{" then
      'frame
      endposition=instr(r$,"}",startposition)
      temp$=mid$(r$,startposition,endposition-startposition+1)
    else
      if mid$(r$,startposition,1)=chr$(34) then
        'string text
        startposition=startposition+1
        endposition=instr(r$,chr$(34),startposition)
        temp$=mid$(r$,startposition,endposition-startposition) 
      end if
      if mid$(r$,startposition,1)="[" then
        'string integers
        startposition=startposition+1
        endposition=instr(r$,"]",startposition)
        temp$=mid$(r$,startposition,endposition-startposition) 
      else
        'integer
        temp$=str$(val(mid$(r$,startposition)))
      end if
    end if
  else
    temp$=""
  end if
  return

[SYSNETWORKGETClicked]
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/sys/network"
  r$=httpget$(url$)
  position=instr(r$,"{",position)+1  
  if position<>0 then
    SYSHANDLERS$(2,2)=mid$(r$,position,len(r$)-1)
  else
    SYSHANDLERS$(2,2)=""
  end if
  goto [Thermostat]

[SYSNETWORKPOSTClicked]
  ESTATUS$="Network POST is Unsupported"
  goto [Thermostat] 

[SYSUPDATERGETClicked]
  ESTATUS$="UPDATER GET is Unsupported"
  goto [Thermostat]

[SYSUPDATERPOSTClicked]
  ESTATUS$="UPDATER POST is Unsupported"
  goto [Thermostat]

[SYSFILESYSTEMGETClicked]
  ESTATUS$="FILESYSTEM GET is Unsupported"
  goto [Thermostat]

[SYSFILESYSTEMPOSTClicked]
  ESTATUS$="FILESYSTEM POST is Unsupported"
  goto [Thermostat]

[SYSFSIMAGEGETClicked]
  ESTATUS$="FILESYSTEMIMAGE GET is Unsupported"
  goto [Thermostat]

[SYSFSIMAGEPOSTClicked]
  ESTATUS$="FILESYSTEMIMAGE POST is Unsupported"
  goto [Thermostat]

[SYSFWIMAGEGETClicked]
  ESTATUS$="FIRMWAREIMAGE GET is Unsupported"
  goto [Thermostat]

[SYSFWIMAGEPOSTClicked]
  ESTATUS$="FIRMWAREIMAGE POST is Unsupported"
  goto [Thermostat]

[SYSCOMMANDGETClicked]
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/sys/command"
  r$=httpget$(url$)
  position=instr(r$,"services")
  if position<>0 then
     startposition=instr(r$,":",position)+2
     endingposition=instr(r$,chr$(34),startposition)-1    
     SYSHANDLERS$(9,2)=mid$(r$,startposition,endingposition-startingposition)
  else
     SYSHANDLERS$(9,2)=""
  end if
  goto [Thermostat]

[SYSCOMMANDPOSTClicked]
  ESTATUS$="no error"
  if #SYSCOMMAND CONTENTS$()<>"" then
    url$="http://";searchTSTATIP$;"/sys/command"
    temp$="{";chr$(34);"command";chr$(34);":";chr$(34);#SYSCOMMAND CONTENTS$();chr$(34);"}"
    r$=httppost$(url$,temp$)
    if instr(r$,"success") then SYSHANDLERS$(8,2)=#SYSCOMMAND CONTENTS$()
  else
    ACTION$="Nothing to POST"
  end if
  goto [Thermostat]

[SYSMODEGETClicked]
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/sys/mode"
  r$=httpget$(url$)
  position=instr(r$,"mode")
  if position<>0 then
     startposition=instr(r$,":",position)+1    
     SYSHANDLERS$(10,2)=str$(val(mid$(r$,startposition)))
  else
     SYSHANDLERS$(10,2)=""
  end if
  goto [Thermostat]

[SYSMODEPOSTClicked]
  ESTATUS$="no error"
  if #SYSMODE CONTENTS$()<>"" then
    url$="http://";searchTSTATIP$;"/sys/mode"
    temp$="{";chr$(34);"mode";chr$(34);":";chr$(34);#SYSMODE CONTENTS$();chr$(34);"}"
    r$=httppost$(url$,temp$)
    if instr(r$,"success") then SYSHANDLERS$(10,2)=#SYSMODE CONTENTS$()
  else
    ACTION$="Nothing to POST"
  end if
  goto [Thermostat]


[SYSNAMEGETClicked]
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/sys/name"
  r$=httpget$(url$)
  position=instr(r$,"name")
  if position<>0 then
     startposition=instr(r$,":",position)+2
     endposition=instr(r$,chr$(34),startposition)   
     SYSHANDLERS$(11,2)=mid$(r$,startposition,endposition-startposition)
  else
     SYSHANDLERS$(11,2)=""
  end if
  goto [Thermostat]

[SYSNAMEPOSTClicked]
  ESTATUS$="no error"
  if #SYSNAME CONTENTS$()<>"" then
    url$="http://";searchTSTATIP$;"/sys/name"
    temp$="{";chr$(34);"name";chr$(34);":";chr$(34);#SYSNAME CONTENTS$();chr$(34);"}"
    r$=httppost$(url$,temp$)
    if instr(r$,"success") then SYSHANDLERS$(11,2)=#SYSNAME CONTENTS$()
  else
    ACTION$="Nothing to POST"
  end if
  goto [Thermostat]

[SYSREBOOTGETClicked]
  ESTATUS$="no error"
  url$="http://";searchTSTATIP$;"/sys/reboot"
  r$=httpget$(url$)
  position=instr(r$,"reboot")
  if position<>0 then
     startposition=instr(r$,":",position)+2
     endposition=instr(r$,chr$(34),startposition)   
     SYSHANDLERS$(12,2)=mid$(r$,startposition,endposition-startposition)
  else
     SYSHANDLERS$(12,2)=""
  end if
  goto [Thermostat]

[SYSREBOOTPOSTClicked]
  ESTATUS$="no error"
  if #SYSREBOOT CONTENTS$()<>"" then
    url$="http://";searchTSTATIP$;"/sys/reboot"
    temp$="{";chr$(34);"reboot";chr$(34);":";chr$(34);#SYSREBOOT CONTENTS$();chr$(34);"}"
    r$=httppost$(url$,temp$)
    if instr(r$,"success") then SYSHANDLERS$(12,2)=#SYSREBOOT CONTENTS$()
  else
    ACTION$="Nothing to POST"
  end if
  goto [Thermostat]


end