  DisplayMessages=0 ' 0=normal, 1=debug
 
  dim TSTATIPS$(10)
  dim TSTATNAMES(10)
  dim SETTING(51)
  dim TSTAT$(18,2)

  for x=0 to 9
    TSTATIPS$(x)=""
    TSTATNAMES$(x)="" 
  next x

'  TSTATIPS$(0)="172.16.1.40"
'  TSTATIPS$(1)="172.16.1.35"

  open "projects\IPList_project\IPList.txt" for input as #IPList
  x=0
  while eof(#IPList)=0
    line input #IPList, TSTATIPS$(x)
    x=x+1
  wend 
  close #IPList
  TSTATIPSIndex=0

  for x=0 to 50
   SETTING(x)=x+45
  next x

  for x=0 to 6
    TSTAT$(x,0)="" 
    TSTAT$(x,1)="" 
  next x

  TSTAT$(0,0)="temp" 
  TSTAT$(1,0)="tmode"
  TSTAT$(2,0)="override"
  TSTAT$(3,0)="hold"
  TSTAT$(4,0)="t_heat"
  TSTAT$(5,0)="t_cool"
  TSTAT$(6,0)="tstate" 

  Message$="From The Bench 255" 

  TSTATIPSIndex=0 
  temp=70
  theat=70 
  tcool=70
  hold=0
  tstate=0 
  goto [GetThermostat]

[Main]
  on error goto [MainErrorHandler]
  tens=int(temp/10)
  units=temp-(10*tens)
  cls
  CSSID #Section1, "{Background-Color: Blue}"
  DIV Section1

  graphic #DRAWBACKGROUND, 256,220
  #DRAWBACKGROUND FILL("BLUE")
  loadimage "0", "public\images\Nixie0.JPG"
  loadimage "1", "public\images\Nixie1.JPG"
  loadimage "2", "public\images\Nixie2.JPG"
  loadimage "3", "public\images\Nixie3.JPG"
  loadimage "4", "public\images\Nixie4.JPG"
  loadimage "5", "public\images\Nixie5.JPG"
  loadimage "6", "public\images\Nixie6.JPG"
  loadimage "7", "public\images\Nixie7.JPG"
  loadimage "8", "public\images\Nixie8.JPG"
  loadimage "9", "public\images\Nixie9.JPG"

  #DRAWBACKGROUND place(40,25)
  #DRAWBACKGROUND FONT("Arial", 20) ' ,"bold", "italic" 
  #DRAWBACKGROUND COLOR("BLACK")
  #DRAWBACKGROUND "\Temperature\"

  #DRAWBACKGROUND drawimage(str$(tens), 64, 35)
  #DRAWBACKGROUND drawimage(str$(units), 128, 35)

  #DRAWBACKGROUND place(196,60)
  #DRAWBACKGROUND FONT("Arial", 20) ' ,"bold", "italic" 
  #DRAWBACKGROUND COLOR("BLACK")
  select case tmode
    case 0
      #DRAWBACKGROUND "\Off\"
    case 1
      #DRAWBACKGROUND "\Heat\"
    case 2
      #DRAWBACKGROUND "\Cool\"
    case 3
      #DRAWBACKGROUND "\Auto\"
  end select

  #DRAWBACKGROUND place(196,100)
  #DRAWBACKGROUND FONT("Arial", 20) ' ,"bold", "italic" 
  #DRAWBACKGROUND COLOR("BLACK")
  if tmode=1 then SETTINGIndex=theat-45
  if tmode=2 then SETTINGIndex=tcool-45 
  #DRAWBACKGROUND "\";str$(SETTING(SETTINGIndex));"\"
  
  #DRAWBACKGROUND place(196,120)
  #DRAWBACKGROUND FONT("Arial", 10) ' ,"bold", "italic" 
  #DRAWBACKGROUND COLOR("BLACK")
  #DRAWBACKGROUND "\Set Point\"

  #DRAWBACKGROUND place(196,160)
  #DRAWBACKGROUND FONT("Arial", 20) ' ,"bold", "italic" 
  #DRAWBACKGROUND COLOR("BLACK")
  if hold=1 then #DRAWBACKGROUND "\Hold\"

  #DRAWBACKGROUND place(40,190)
  #DRAWBACKGROUND FONT("Arial", 15) ' ,"bold", "italic" 
  #DRAWBACKGROUND COLOR("BLACK")  
  #DRAWBACKGROUND "\";TSTATNAMES$(TSTATIPSIndex);"\"

  #DRAWBACKGROUND place(60,215)
  #DRAWBACKGROUND FONT("Arial", 15) ' ,"bold", "italic" 
  #DRAWBACKGROUND COLOR("BLACK") 
  if tstate= 0 then #DRAWBACKGROUND "\  System Off  \"
  if tstate= 1 then #DRAWBACKGROUND "\System Heating\"
  if tstate= 2 then #DRAWBACKGROUND "\System Cooling\"

  render #DRAWBACKGROUND

  CSSID #Section2,  "{Color: white; Font-Weight: Bold;}"
  DIV Section2

  print 
  print "  Thermostat List:    Set Point:"; : print : print

  End DIV

  print "   ";
  listbox #THERMOSTATLIST, TSTATIPS$(), 1
  #THERMOSTATLIST SELECT(TSTATIPS$(TSTATIPSIndex))
  print "         "; 
  listbox #SETTING, SETTING(), 1
  #SETTING SELECT(SETTING(SETTINGIndex))
  print

  print "     "; : button #SELECTTHERMOSTAT, "Select", [SELECTTHERMOSTAT] 
  print "            "; : button #SELECTSETPOINT, "Select", [SELECTSETPOINT] : print

  print
  print "   "; : button #HOLD, "Toggle Hold", [TOGGLEHOLD] 
  print " "; : button #MODE, "Toggle Mode", [TOGGLEMODE] : print

  print
  print "   "; : button #UPDATE, "Update Changed Settings", [UPDATE] : print
  print
  print "   "; : textbox #Message, Message$, len(Message$)
  print
  end DIV

  wait

[SELECTSETPOINT]
  for x=0 to 50
    if SETTING(x)=val(#SETTING SELECTION$()) then
      SETTINGIndex=x
      if tmode=1 then theat=SETTING(x)
      if tmode=2 then tcool=SETTING(x)
    end if
  next x
  if DisplayMessages=1 then
    if tmode=1 then Message$="theat=";theat
    if tmode=2 then Message$="tcool=";tcool
  end if
  goto [Main]

[TOGGLEHOLD]
  hold=hold xor 1
  if DisplayMessages=1 then Message$="Hold=";hold
  goto [Main]

[SELECTTHERMOSTAT]
  Message$="From The Bench 255"
  for x=0 to 9
    if TSTATIPS$(x)=#THERMOSTATLIST SELECTION$() then TSTATIPSIndex=x
  next x 
  if DisplayMessages=1 then Message$=TSTATIPS$(TSTATIPSIndex)
  goto [GetThermostat]

[TOGGLEMODE]
  if tmode=1 then
    tmode=2
    goto [TOGGLEMODEEXIT]
  end if
  if tmode=2 then tmode=1
  
[TOGGLEMODEEXIT]
  if DisplayMessages=1 then Message$="TMode=";tmode
  goto [Main] 

[UPDATE]
  Message$="From The Bench 255" 
  searchIP$=TSTATIPS$(TSTATIPSIndex)
  url$="http://"; searchIP$; "/tstat"
  temp$="{"; chr$(34); "tmode"; chr$(34); ":"; tmode; ","; chr$(34); "hold"; chr$(34); ":"; hold
  if tmode=0 then temp$=temp$; "}" 
  if tmode=1 then temp$=temp$; ","; chr$(34); "t_heat"; chr$(34); ":"; str$(theat); "}"
  if tmode=2 then temp$=temp$; ",";chr$(34); "t_cool"; chr$(34); ":"; str$(tcool); "}"
  if tmode=3 then temp$=temp$; ",";chr$(34); "t_heat"; chr$(34); ":"; str$(theat); ","
  if tmode=3 then temp$=temp$; chr$(34); "t_cool"; chr$(34); ":"; str$(tcool); "}"

  r$=httppost$(url$,temp$)
  if DisplayMessages=1 then Message$=r$
  goto [Main]

[GetThermostat]
  searchIP$=TSTATIPS$(TSTATIPSIndex)
  response$=shell$("ping -n 1 ";searchIP$)
  goodresponse$="Reply from ";searchIP$

  if instr(response$,goodresponse$) then
    url$="http://";searchIP$;"/sys/name"
    r$=httpget$(url$)

    temp$="name"
    gosub [LookThroughResponse]
    TSTATNAMES$(TSTATIPSIndex)=temp$

    url$="http://";searchIP$;"/tstat"
    r$=httpget$(url$)

    for x=0 to 6
      temp$=TSTAT$(x,0)
      gosub [LookThroughResponse]
      TSTAT$(x,1)=temp$
    next x

    if TSTAT$(0,1)<>"" then temp=int(val(TSTAT$(0,1)))
    if TSTAT$(1,1)<>"" then tmode=val(TSTAT$(1,1))
    if TSTAT$(2,1)<>"" then override=val(TSTAT$(2,1))
    if TSTAT$(3,1)<>"" then hold=val(TSTAT$(3,1))
    if TSTAT$(4,1)<>"" then theat=int(val(TSTAT$(4,1)))
    if TSTAT$(5,1)<>"" then tcool=int(val(TSTAT$(5,1)))
    if TSTAT$(6,1)<>"" then tstate=val(TSTAT$(6,1))

    if DisplayMessages=1 then Message$=r$

  else
    Message$="No response from ";searchIP$

  end if
  goto [Main]

[MainErrorHandler]
  Message$="Command unsuccessful :";Err$;" from ";searchIP$
  goto [Main]

[LookThroughResponse]
' search string in temp$, result in temp$
  position=instr(r$,temp$)
  if position<>0 then
    position=instr(r$,":",position)
    if mid$(r$,position+1,1)=chr$(34) then
      'string
      startposition=position+2
      endposition=instr(r$,chr$(34),startposition)
      temp$=mid$(r$,startposition,endposition-startposition) 
    else
      'integer
      startposition=position+1
      temp$=str$(val(mid$(r$,startposition)))
    end if
  else
    temp$=""
  end if
  return

end 